﻿using wscf.lightblue.Build;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Diagnostics;

namespace wscf.lightblue.Test
{
	[TestClass()]
	public class ActivityBaseTest
	{
		[TestInitialize()]
		public void TestInitialize()
		{
			Activity.Log += new LogHandler(OnLog);
			Activity.Error += new ErrorHandler(OnActivityError);
		}

		[TestCleanup()]
		public void TestCleanup()
		{
			Activity.Log -= new LogHandler(OnLog);
			Activity.Error -= new ErrorHandler(OnActivityError);
		}

		static private void OnLog(object sender, string message)
		{
			Debug.Print(message);
		}

		static private void OnActivityError(object sender, string message, Exception exc)
		{
			Debug.Print(message);
		}

	}
}
