﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.ComponentModel;

namespace wscf.lightblue.Build
{
	public class BuildServiceAssemblies : EnumerateFiles
	{
		public string ServiceAssembliesFolder { get; set; }

		public string ServiceAssemblyPrefix { get; set; }

		public List<string> ReferencedAssemblies { get; set; }

		public bool Debug { get; set; }

		public override void Execute()
		{
			OnLog(ToString());
			base.Execute();
		}

		protected override void OnFile(string file)
		{
			InvokeVisualStudioTool p = new InvokeVisualStudioTool
			{
				Name = "Build Service Contract Assembly",
				FileName = "csc",
				Arguments = string.Format("/t:library {0} /out:\"{1}\\{2}{3}\" \"{4}\" /nologo /debug{5}",
					GetReferences(),
					GetBuildTempFolder(),
					ServiceAssemblyPrefix,
					Path.ChangeExtension(Path.GetFileName(file), ".dll"),
					file,
					Debug ? "+" : "-")
			};
			p.Execute();
			if (p.IsError)
			{
				m_IsError = true;
			}
		}

		private string GetReferences()
		{
			string r = string.Empty;
			if (ReferencedAssemblies != null)
			{
				foreach (string file in ReferencedAssemblies)
				{
					if (!string.IsNullOrEmpty(r))
					{
						r += "\" /r:\"";
					}
					r +=Path.Combine(ServiceAssembliesFolder, Path.GetFileName(file));
				}
			}
			if (!string.IsNullOrEmpty(r))
			{
				r = "/r:\"" + r + "\"";
			}
			return r;
		}

	}
}
