﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.ComponentModel;

namespace wscf.lightblue.Build
{
	public class EnumerateFiles : Activity
	{
		public string Folder { get; set; }

		public string SearchPattern { get; set; }

		public List<string> Files { get; set; }

		public override void Execute()
		{
			base.Execute();
			if (Files == null)
			{
				Files = new List<string>();
			}
			try
			{
				DirectoryInfo di = new DirectoryInfo(Folder);
				if (Directory.Exists(Folder))
				{
					Files.Clear();
					foreach (string file in Directory.EnumerateFiles(Folder, SearchPattern))
					{
						LogIndent();
						try
						{
							Files.Add(file);
							OnFile(file);
						}
						finally
						{
							LogUnIndent();
						}
					}
				}
			}
			catch (Exception e)
			{
				OnError(e);
			}
		}

		protected virtual void OnFile(string file)
		{
		}

		public override string ToString()
		{
			return string.Format("{0} [{1}]", base.ToString(), Folder);
		}
	}
}
