﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace wscf.lightblue.Build
{
	public class InvokeShellCommand : Activity
	{
		public string Command { get; set; }

		public string WorkingDirectory { get; set; }
		
		private bool m_UseShellExecute = false;

		public bool UseShellExecute
		{
			get
			{
				return m_UseShellExecute;
			}
			set
			{
				m_UseShellExecute = value;
			}
		}

		private string m_ConsoleOutput = "";

		public string ConsoleOutput
		{
			get
			{
				return m_ConsoleOutput;
			}
		}

		public override void Execute()
		{
			base.Execute();
			string cmdFile = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData),
				"wscf.lightblue.Build.InvokeShellCommand.cmd");
			using (TextWriter tw = new StreamWriter(cmdFile, false))
			{
				tw.Write(Command);
				tw.Close();
			} 
			InvokeProcess p = new InvokeProcess
			{
				Name = this.Name,
				FileName = cmdFile,
				WorkingDirectory = WorkingDirectory,
				UseShellExecute = UseShellExecute
			};
			p.Execute();
			m_ConsoleOutput = p.ConsoleOutput;
			if (p.ExitCode != 0)
			{
				OnError(new Exception(string.Format("Exitcode: {0}", p.ExitCode)));
			}
		}

		public override string ToString()
		{
			return string.Format("{0} [{1}]",
				base.ToString(), this.Command);
		}
	}
}
