﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace wscf.lightblue.Build
{
	public class Sequence: Activity
	{
		public List<Activity> Activities { get; set; }

		[DefaultValue(false)]
		public bool ContinueOnError {get; set; }
		
		public Sequence()
		{
			Activities = new List<Activity>();
		}

		public override void Execute()
		{
			base.Execute();
			OnLog(ToString());
			foreach (Activity a in Activities)
			{
				try
				{
					LogIndent();
					if (a != null)
					{
						a.Execute();
						if (a.IsError)
						{
							m_IsError = true;
						}
					}
				}
				catch (Exception e)
				{
					OnError(e);
					m_IsError = true;
				}
				finally
				{
					LogUnIndent();
				}
				if (!ContinueOnError && m_IsError)
				{
					break;
				}
			}
		}
	}
}
